// DC_Ex.h: CDC_Ex NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DC_EX_H__9BFE3BA5_2D22_4092_82B2_693433E67B52__INCLUDED_)
#define AFX_DC_EX_H__9BFE3BA5_2D22_4092_82B2_693433E67B52__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define DE_BASE_SIZE	4		//	{TCY
#define DE_PENSTYLE_CNT	7		//	ỹX^C̓o^

enum DE_PENSTYLE_CODE{			//	ỹX^C
	DE_PS_SOLID, DE_PS_DASH, DE_PS_DOT,
	DE_PS_DASHDOT, DE_PS_DASHDOTDOT, DE_PS_NULL,
	DE_PS_DOUBLE
};

//////////////////////////////////////////////////////////////////////

class DLL_EXPORT CPenData{		//	yNX
public:
	DE_PENSTYLE_CODE style;		//	X^C
	int width;					//	
	COLORREF color;				//	J[

public:
	CPenData();
	CPenData(DE_PENSTYLE_CODE, int, COLORREF);

	void SetData(DE_PENSTYLE_CODE, int, COLORREF);				//	yݒ

	CPenData& operator =(const CPenData&);						//	
    friend BOOL operator ==(const CPenData&, const CPenData&);	//	
    friend BOOL operator !=(const CPenData&, const CPenData&);	//	Ȃ
};

//////////////////////////////////////////////////////////////////////

class DLL_EXPORT CBorderData{	//	g̃yNX
public:
	CPenData top;
	CPenData bottom;
	CPenData left;
	CPenData right;

public:
	void SetData(DE_PENSTYLE_CODE, int, COLORREF);	//	yݒ
	void SetStyle(DE_PENSTYLE_CODE);				//	X^Cݒ
	void SetWidth(int);								//	ݒ
	void SetColor(COLORREF);						//	J[ݒ

	CBorderData& operator =(const CBorderData&);						//	
    friend BOOL operator ==(const CBorderData&, const CBorderData&);	//	
    friend BOOL operator !=(const CBorderData&, const CBorderData&);	//	Ȃ
};

//////////////////////////////////////////////////////////////////////

class DLL_EXPORT CDC_Ex  
{
private:
	static BOOL m_CreateTable;							//	^Oe[u\zς݁H
	static CString m_pStyleTable[DE_PENSTYLE_CNT];		//	ỹX^C̃e[u

private:
	int m_lStyle;			//	̃X^C
	int m_lWidth;			//	

	int xpos, ypos;			//	݈ʒu
	int drawpixel;			//	pixel
	CPen SolidPen;			//	py
	CPen NullPen;			//	py
	COLORREF pencolor;		//	y̐F
	COLORREF backcolor;		//	wiF


public:
	CDC_Ex();
	virtual ~CDC_Ex();

	void CreateTable();						//	e[u\z
	void CreatePStyleTable();				//	ỹX^C̃e[u\z

	void CreatePen(const CPenData&);		//	y쐬
	void CreatePen(int, int, COLORREF);
	void DeletePen(void);					//	y폜

	void SetLPattern(int);					//	̃p^[ݒ
	void SetBackColor(COLORREF);			//	wiFݒ

	//	}``
	void DrawTriangle(CDC*, const CPoint&, const CPoint&, const CPoint&);		//	Op`
	void DrawSquare(CDC*, const CPoint&, const CPoint&,							//	lp`
					const CPoint&, const CPoint&);

	//	}`hԂ
	void DrawTriangleCover(CDC*, const CPoint&, const CPoint&, const CPoint&);	//	Op`
	void DrawSquareCover(CDC*, const CPoint&, const CPoint&,					//	lp`
						 const CPoint&, const CPoint&);

	//	w肵FŐ}`hԂ
	void DrawTriangleCover(CDC*, const CPoint&, const CPoint&,					//	Op`
						   const CPoint&, const COLORREF&);
	void DrawSquareCover(CDC*, const CPoint&, const CPoint&,					//	lp`
						 const CPoint&, const CPoint&, const COLORREF&);

	void MoveTo(CDC*, const CPoint&);			//	spɌ݈ʒuړ
	void LineTo(CDC*, const CPoint&);			//	݈ʒuep܂Ő`
	void LineTo(CDC*, const CPoint&, const CPoint&, const CPenData&);			//	w肵yŁAspep܂Ő`
	void LineTo(CDC*, int, int, int, int, const CPenData&);						//	w肵yŁA(x1, y1)(x2, y2)܂Ő`

	DE_PENSTYLE_CODE GetPStyleCode(CString);	//	ỹX^C̎ގ擾
	int GetPWidth_Top(const CPenData&);			//	yŕ`悵ƂAw肵sNZ͂ݏoTCY擾 [pixel]
	int GetPWidth_Bottom(const CPenData&);
	int GetPWidth_Left(const CPenData&);
	int GetPWidth_Right(const CPenData&);

	void SortPoint(int, CPoint*);				//	w̏Ƀ\[g



	void DrawCircle(CDC* mydc, CPoint x, int diameter);			//	~``
	void DrawCircle_X(CDC* mydc, CPoint x, int diameter);		//	~`{~`
	void DrawCircleCover(CDC* mydc, CPoint x, int diameter);	//	~`hԂ
	void DrawTriangle_alpha(CDC* mydc, CPoint x,				//	ċNŎOp`A`
							CPoint y, CPoint z);
	void DrawTriangleCover_alpha(CDC* mydc, CPoint x,			//	ċAŁixj
								 CPoint y, CPoint z);
	void DrawArrow(CDC* mydc, CPoint point, CPoint base,		//	`
					int style, int arrow_size = 7, int opening_angle = 30);
	void DrawPoint(CDC* mydc, int x, int y,						//	_`
							  int size, int pattern);
	void DrawPoint3D(CDC* mydc, int x, int y,					//	Rc_`
							  int size, int pattern);
	COLORREF Get3DColor(COLORREF color, int mode);
	void BitBlt_Trans(CDC* mydc, int x, int y,					//	rbg}bvwFœ߃Rs[
					  int width, int height,
					  CDC* srcdc,
					  int xsrc, int ysrc, COLORREF transcolor);

	void MoveTo(CDC*, int, int);				//	݈ʒuړ
	void LineTo(CDC*, int, int);				//	݈ʒu(x, y)܂Ő`
	void LineTo(CDC*, int, int, int, int);		//	݈ʒu(x1, y1)ɈړA(x2, y2)܂Ő`
};

#endif // !defined(AFX_DC_EX_H__9BFE3BA5_2D22_4092_82B2_693433E67B52__INCLUDED_)
