// MathString.h: CMathString NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MATHSTRING_H__FFAD8A27_7269_43A1_BE86_35B3742B56D3__INCLUDED_)
#define AFX_MATHSTRING_H__FFAD8A27_7269_43A1_BE86_35B3742B56D3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "MathString_stdlib.h"		//	MathStringpWCu
#include "FontTool.h"
#include "StringTool.h"
#include "Queue_Ex.h"
#include "Stack_Ex.h"
#include "DC_Ex.h"

class DLL_EXPORT CMathString  
{
private:
	static BOOL m_CreateTable;								//	^Oe[u\zς݁H
	static MS_TAG_TABLE m_tagTable[MS_NUM_TAG];				//	^Oe[u
	static CString m_tagPropertyTable[MS_NUM_TAG_PROPERTY];	//	^Õe[u
	static CString m_tagStyleTable[MS_NUM_TAG_STYLE];		//	^ÕX^C̃e[u
	static CString m_hAlignTable[MS_NUM_HALIGN];			//	̃eLXgzũe[u
	static CString m_vAlignTable[MS_NUM_VALIGN];			//	̃eLXgzũe[u
	static CString m_parenTable[MS_NUM_PAREN];				//	ϊʂ̃e[u

	static BOOL m_modified;									//	ݒɕύX
	static MS_CNG_PTAG m_pTagCng[MS_NUM_PTAG];				//	zun^O̐ݒ
	static MS_CNG_CTAG m_cTagCng[MS_NUM_CTAG];				//	n^O̐ݒ
	static MS_CNG_PAREN m_parenCng[MS_NUM_PAREN];			//	ϊʂ̐ݒ

	//	ftHgݒ
	static LOGFONT m_def_lf;				//	WLOGFONT
	static COLORREF m_def_txtclr;			//	eLXgJ[
	static MS_HALIGN_CODE m_def_hAlign;		//	̃eLXgzu
	static MS_VALIGN_CODE m_def_vAlign;		//	̃eLXgzu

	static int m_spaceChar;					//	Ԃ̗] [pixel]
	static int m_spaceLine;					//	sԂ̗] [pixel]
	static BOOL m_changeSpaceChar;			//	Yɗ]ύX邩
	static BOOL m_changeSpaceLine;

	//	^O̓ʐݒ
	static int m_Sub_ptRatio;				//	ỸtHgTCY []
	static int m_Top_positionY;				//	tŶx\ʒu̒l []
	static int m_Btm_positionY;				//	tŶx\ʒu̒l []
	static int m_RTop_positionY;			//	EtŶx\ʒu̒l []
	static int m_RBtm_positionY;			//	EtŶx\ʒu̒l []
	static MS_VALIGN_CODE m_Table_vAlign;	//	\̐̃eLXgzu
	static int m_Frac_marginBar;			//	qEeLXg̉̕_̊O̗] []
	static int m_Frac_marginX;				//	qEeLXg̍E̊O̗] []
	static double m_Frac_barAscentRatio;	//	̉_܂ł̃AZgƁA_ɎgptHg̃AZgƂ̔
	static int m_Sqrt_marginTop;			//	̃eLXg̏̊O̗] []
	static int m_Sqrt_marginX;				//	̃eLXg̍E̊O̗] []
	static double m_Sqrt_barAscentRatio;	//	̉_܂ł̃AZgƁA_ɎgptHg̃AZgƂ̔
	static double m_Sqrt_DescentRatio;		//	ɎgptHg̃fZgƁAAZgƂ̔
	static double m_Sqrt_nAscentRatio;		//	n敔̉܂ł̃AZgƁA_ɎgptHg̃AZgƂ̔
	static double m_Sqrt_nWidthRatio;		//	n敔̉E܂ł̉ƁA_ɎgptHg̉Ƃ̔
	static char m_Sqrt_code;				//	̕R[h
	static MS_CNG_FONT m_Sqrt_font;			//	̃tHgݒ
	static int m_Paren_marginY;				//	ϊʂ̃eLXg̏㉺̊O̗] []

public:
	CDC* m_pDC;								//	DCpď
	int m_textLength;						//	\eLXg̕
	MS_TXT_EXTENT m_textExtent;				//	\eLXg̕\TCY
	CString m_text;							//	\eLXg

	CQueue_Ex<MS_DATA_LINE> m_lQueue;		//	͂si[L[
	CQueue_Ex<MS_DATA_TAG> m_tQueue;		//			^Oi[L[
	CQueue_Ex<MS_DATA_TABLE> m_tableQueue;	//			\i[L[
	CQueue_Ex<MS_DATA_FONT> m_fontQueue;	//			tHgi[L[
	CFontTool m_fTool;						//	tHgpc[
	CStringTool m_sTool;					//	CStringpc[
	CDC_Ex m_dcEx;							//	`揈p

	BOOL m_error;							//	ɃG[
	CString m_errorMsg;						//	G[bZ[W
	LONG m_lfEscapement;					//	eLXg̊px [0.1deg]
	double m_sin;							//	eLXǧX΂ɑ΂sin
	double m_cos;							//						  cos

	//	GetTagTokenp
	int m_sIdx;								//	Jnʒu
	int m_quart;							//	_uNI[g̐


public:
	CMathString();
	virtual ~CMathString();

	BOOL SetText(CDC*, CString);			//	\eLXgݒ
	BOOL TextOut(CDC*, int, int);			//	\eLXgw肵ʒuɏo
	BOOL TextOut(CDC*, CPoint);

	CString GetText();						//	\eLXg擾
	CSize GetTextExtent(CDC*);				//	\eLXg̕\TCY擾
	MS_TXT_EXTENT GetTextExtent_Ex(CDC*);

	CString GetFormalText(const CString&, CString);		//	sR[hAs̔pXy[XE^u폜

	//	p[^ݒ
	void SetParam_LOGFONT(const LOGFONT&);	//	WLOGFONTݒ
	void SetParam_lfHeight(LONG);			//	tHg̍ݒ [pixel]
	void SetParam_lfEscapement(LONG);		//	eLXg̊pxݒ [0.1deg]
	void SetParam_SubPtRatio(int);			//	ỸtHgTCYݒ []
	void SetParam_SpaceLine(int);			//	sԂ̗]ݒ [pixel]

private:
	void CreateTable();						//	e[u\z
	void CreateTagTable();					//	^Oe[u\z
	void CreateTagPropertyTable();			//	^Õe[u\z
	void CreateTagStyleTable();				//	^ÕX^C̃e[u\z
	void CreateHAlignTable();				//	̃eLXgzũe[u\z
	void CreateVAlignTable();				//	̃eLXgzũe[u\z
	void CreateParenTable();				//	ϊʂ̃e[u\z

	void SetPTagCng();						//	zun^Oݒl̐ݒ
	void SetCTagCng();						//	n^Oݒl̐ݒ
	void SetParenCng();						//	ϊʂ̐ݒl̐ݒ
	void SetDefaultPara();					//	WlZbg

	void SetModified(BOOL =TRUE);			//	ݒύX̃`FbN
	void SetDefaultTagProperty(MS_TAG_PROPERTY*, MS_TAG_CODE,	//	^ÕftHglݒ
							   const MS_TXT_STATE*, LPARAM lpData=-1);
	void SetTState_Sub(MS_TXT_STATE*, int);						//	ỸeLXgԂݒ
	void SetTState_Font(MS_TXT_STATE*, const MS_DATA_FONT&);	//	tHgύX̃eLXgԂݒ
	void SetLOGFONT(LOGFONT*, const MS_CNG_FONT&);				//	tHgLOGFONT\̂ɐݒ


	//	
	void AnalyzeText();											//	eLXg
	MS_TXT_EXTENT AnalyzeText_Multi(int, MS_TXT_STATE*, int*);											//	sIdx畡s
	MS_TXT_EXTENT AnalyzeText_Single(int, MS_TXT_STATE*, CFont*, CFont*, MS_DATA_FONT*,					//	sIdxPs
								CStack_Ex<MS_DATA_FONT>*, int*, BOOL*);
	void AnalyzeText_Div(int, MS_TXT_STATE*, MS_DATA_TAG*, const MS_TAG_PROPERTY&);						//	ubNvf̉
	void AnalyzeText_PTag(MS_TAG_CODE, int, MS_TXT_STATE*, MS_DATA_TAG*, const MS_TAG_PROPERTY&);		//	Y^Ỏ́iSUP,SUBj
	void AnalyzeText_PTag_Ex(MS_TAG_CODE, int, MS_TXT_STATE*, MS_DATA_TAG*, const MS_TAG_PROPERTY&);	//	Y^Ỏ́iTOPj
	void AnalyzeText_Frac(int, MS_TXT_STATE*, MS_DATA_TAG*, const MS_TAG_PROPERTY&);					//	̉
	void AnalyzeText_Sqrt(int, MS_TXT_STATE*, MS_DATA_TAG*, const MS_TAG_PROPERTY&);					//	̉
	void AnalyzeText_SqrtN(int, MS_TXT_STATE*, MS_DATA_TAG*, const MS_TAG_PROPERTY&);					//	n捪̉
	void AnalyzeText_Paren(int, MS_TXT_STATE*, MS_DATA_TAG*, const MS_TAG_PROPERTY&);					//	ϊʂ̉
	void AnalyzeText_Table(int, MS_TXT_STATE*, MS_DATA_TABLE*, const MS_TAG_PROPERTY&);					//	\̉
	void AnalyzeText_Font(MS_DATA_FONT*, MS_TXT_STATE*, const MS_TAG_PROPERTY&);						//	tHg̉
	void AnalyzeText_Mark(MS_TAG_CODE, MS_TXT_STATE*, MS_TXT_EXTENT*);									//	L̉

	MS_TXT_EXTENT AnalyzeText_String(int, int, MS_TXT_STATE*);				//	m_textsIdx`eIdx܂ł̕\TCY擾
	MS_TXT_EXTENT AnalyzeText_Char(char, LOGFONT*, const MS_CNG_FONT&);		//	̕\TCY擾
	int AnalyzeText_CharParen(MS_PAREN_CODE, LOGFONT);						//	ʂ̕\擾


	//	o
	void TextOut_Multi(int, MS_TXT_STATE*, CPoint, int);								//	sIdx畡so
	void TextOut_Single(int, MS_TXT_STATE*, CFont*, CFont*, BOOL*, CPoint, double);		//	sIdxPso
	void TextOut_Div(int, MS_TXT_STATE*, CPoint, const MS_DATA_TAG*);					//	ubNvf̏o
	void TextOut_PTag(MS_TAG_CODE, int, MS_TXT_STATE*, CPoint, const MS_DATA_TAG*);		//	Y^ȌóiSUP,SUBj
	void TextOut_PTag_Ex(MS_TAG_CODE, int, MS_TXT_STATE*, CPoint, const MS_DATA_TAG*);	//	Y^ȌóiTOPj
	void TextOut_Frac(int, MS_TXT_STATE*, CPoint, const MS_DATA_TAG*);					//	̏o
	void TextOut_Sqrt(int, MS_TXT_STATE*, CPoint, const MS_DATA_TAG*);					//	̏o
	void TextOut_SqrtN(int, MS_TXT_STATE*, CPoint, const MS_DATA_TAG*);					//	n捪̏o
	void TextOut_Paren(int, MS_TXT_STATE*, CPoint, const MS_DATA_TAG*);					//	ϊʂ̏o
	void TextOut_Table(int, MS_TXT_STATE*, CPoint, MS_DATA_TABLE*);						//	\̏o
	int TextOut_Mark(MS_TAG_CODE, MS_TXT_STATE*, CPoint);								//	L̏o

	double TextOut_String(int, int, MS_TXT_STATE*, CPoint);					//	m_textsIdx`eIdx܂ŏóA\擾
	int TextOut_Char(char, LOGFONT*, const MS_CNG_FONT&, CPoint);			//	óA\擾
	void TextOut_CharParen(MS_PAREN_CODE, LOGFONT, COLORREF,				//	ϊʂ̏o
						   CPoint, int, const MS_TXT_EXTENT&);


	void AddExtent(MS_TXT_EXTENT*, const MS_TXT_EXTENT&);					//	\TCYZ
	void AddExtent_Border(MS_TXT_EXTENT*, const CBorderData&);				//	\TCYɘg̐Z
	void AddExtent_Margin(MS_TXT_EXTENT*, const CRect&);					//	\TCYɏ㉺E̊O̗]Z
	void AddExtent_Padding(MS_TXT_EXTENT*, const CRect&);					//	\TCYɏ㉺E̗̓]Z

	MS_TXT_EXTENT GetExtent_PTag(const MS_DATA_TAG*, int baseHeight=0);		//	]AeLXg̕\TCY擾
	MS_TXT_EXTENT GetExtent_vAlign(MS_TXT_STATE*, MS_TXT_EXTENT);			//	ɔzu̕\TCY擾

	CPoint GetPos_MoveX(CPoint, double);									//	ړAeLXg\Jnʒu擾
	CPoint GetPos_MoveY(CPoint, double);									//	ړAeLXg\Jnʒu擾
	CPoint GetPos_LTop(CPoint, const MS_TXT_EXTENT&, UINT);					//	ubN̍ʒu擾
	CPoint GetPos_hAlign(double*, CPoint, const MS_TXT_STATE*, int, int);	//	̃eLXgzuAeLXg\JnʒuAԂ̗]擾
	void GetPos_BorderVtx_PTag(CPoint (*pVtx)[2], CPoint,					//	g̒_擾
							   const MS_DATA_TAG*, int baseHeight=0);
	CPoint GetPos_LBase_PTag(CPoint, const MS_DATA_TAG*);					//	eLXg̍x[XCʒu擾

	CString GetTagToken(CString, int);										//	^Õg[N擾iidx=-1őēǂ݂Ƃj
	int GetTagIdx(MS_TAG_CODE, BOOL, int =0);								//	w肵ނ̃^ÓA^OI̎idx擾iĂяoAGetTagTokenŒl擾\j
	int GetTagIdx_Ex(MS_TAG_CODE, BOOL, MS_TAG_CODE, BOOL, BOOL*, int =0);	//	iQނ̃^ÔAɌꂽidx擾j
	int GetETagIdx(int);													//	^OĨCfbNX擾
	MS_TAG_CODE GetSTagCode(const CString&);								//	^OJn̎ގ擾
	MS_TAG_PROPERTY_CODE GetTagPropertyCode(const CString&);				//	^O̎ގ擾
	MS_TAG_STYLE_CODE GetTagStyleCode(const CString&);						//	^ÕX^C̎ގ擾
	MS_PAREN_CODE GetParenCode(const CString&);								//	ϊʂ̎ގ擾

	void GetTagProperty(MS_TAG_PROPERTY*);									//	^O̐ݒl擾
	void GetHAlign(MS_TAG_PROPERTY*, CString*);								//	̃eLXgzu̐ݒ擾
	void GetVAlign(MS_TAG_PROPERTY*, CString*);								//	̃eLXgzu̐ݒ擾
	void GetTagStyle(MS_TAG_STYLE*, CString*);								//	^ÕX^C̐ݒl擾
	void GetParenType(MS_PAREN_CODE*, MS_PAREN_CODE*, const CString&);		//	ϊʂ̃^Cv擾

	int GetFontWidth_Sqrt(int, const MS_TXT_STATE*);						//	ɎgptHglfWidth擾
	int GetFontWidth_Paren(int, const MS_TXT_STATE*);						//	ϊʂɎgptHglfWidth擾
	int GetBarWidth(int);													//	_̐擾

	void DrawBgColor(const CPoint&, const CPoint&,				//	wiFhԂ
					 const CPoint&, const CPoint&,
					 const COLORREF&);
	void DrawBorder(CPoint (*pVtx)[2], const CBorderData&);		//	㉺E̘g`
	void DrawBorderTop(CPoint, CPoint, const CPenData&);		//	g`
	void DrawBorderBtm(CPoint, CPoint, const CPenData&);
	void DrawVBorder(CPoint, CPoint, const CPenData&);

	//	mێsp̃G[΍
	void AnalyzeErrorBuffer();									//	͎̃G[
	void TextOutErrorBuffer();									//	õ͎G[						
};

#endif // !defined(AFX_MATHSTRING_H__FFAD8A27_7269_43A1_BE86_35B3742B56D3__INCLUDED_)
