// MathTagQueue.h: CMathTagQueue NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_QUEUE_EX_H__2FFAD245_36B4_42A5_8FA2_8DA84E609B4F__INCLUDED_)
#define AFX_QUEUE_EX_H__2FFAD245_36B4_42A5_8FA2_8DA84E609B4F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define QUEUE_EX_TEMPLATE	template <typename DATA>
#define CQueue_ExT			CQueue_Ex<DATA>

QUEUE_EX_TEMPLATE class DLL_EXPORT CQueue_Ex
{
private:
	struct QUEUE_DATA{						//	L[p\
		DATA data;							//	f[^
		QUEUE_DATA* next;					//	̃f[^ւ̃|C^
	};

	BOOL m_error;							//	̃G[
	int m_dataCnt;							//	f[^
	QUEUE_DATA *m_head, *m_foot;			//	L[̐擪A
	QUEUE_DATA* m_look;						//	Qƈʒu


public:
	CQueue_Ex();
	virtual ~CQueue_Ex();

	DATA* Enqueue(DATA&);					//	GL[
	DATA* Enqueue(DATA&, void*);			//	}ʒuw^GL[
	BOOL Dequeue(DATA*);					//	fL[
	void DeleteQueue();						//	L[폜

	BOOL Seek(int);							//	w肳ꂽʒuɎQƈʒuړ
	BOOL GetData(DATA*);					//	Qƈʒũf[^擾iCNgtj
	DATA* GetPointer();						//	Qƈʒũ|C^擾iCNgtj

	BOOL IsError();							//	G[ĂꍇTRUEԂ
	int GetSize();							//	f[^擾
	void* GetFootPointer();					//	L[̖̃|C^擾

	CQueue_ExT& operator =(CQueue_ExT&);	//	iG[΍Kvj
};

#endif // !defined(AFX_QUEUE_EX_H__2FFAD245_36B4_42A5_8FA2_8DA84E609B4F__INCLUDED_)



//////////////////////////////////////////////////////////////////////
// CQueue_Ex
// \z/
//////////////////////////////////////////////////////////////////////

QUEUE_EX_TEMPLATE CQueue_ExT::CQueue_Ex()
{
	m_error = FALSE;		//	̃G[
	m_dataCnt = 0;			//	f[^
	m_head = NULL;			//	L[̐擪A
	m_foot = NULL;
	m_look = NULL;			//	Qƈʒu
}

QUEUE_EX_TEMPLATE CQueue_ExT::~CQueue_Ex()
{
	DeleteQueue();			//	L[폜
}

//////////////////////////////////////////////////////////////////////

QUEUE_EX_TEMPLATE DATA* CQueue_ExT::Enqueue(DATA& data)
{
	QUEUE_DATA* newData = new QUEUE_DATA;		//	m
	if(newData == NULL)		return NULL;		//	mێs

	newData->data = data;						//	f[^eݒ
	newData->next = NULL;

	if(m_foot == NULL){							//	L[Ȃ
		m_head = m_foot = m_look = newData;		//	e|C^ɓo^
	}
	else{
		m_foot->next = newData;					//	L[̖ɒǉ
		m_foot = newData;						//	ʒuXV
	}

	m_dataCnt++;								//	f[^Z
	return &(newData->data);					//	GL[f[^ւ̃|C^Ԃ
}

QUEUE_EX_TEMPLATE DATA* CQueue_ExT::Enqueue(DATA& data, void* p)
{
	QUEUE_DATA* pInsert = (QUEUE_DATA *)p;		//	}ʒuւ̃|C^擾
	QUEUE_DATA* newData = new QUEUE_DATA;		//	m
	if(newData == NULL)		return NULL;		//	mێs

	newData->data = data;						//	f[^eݒ
	if((QUEUE_DATA **)pInsert == &m_head){		//	}ʒum_head̃AhXێĂȂAL[̐擪ɑ}
		if(m_foot == NULL){						//	L[Ȃ
			newData->next = NULL;
			m_head = m_foot = m_look = newData;	//	e|C^ɓo^
		}
		else{
			newData->next = m_head;				//	݂̃L[̐擪̃f[^ɐݒ
			m_head = newData;					//	L[̐擪ɑ}
		}
	}
	else{
		newData->next = pInsert->next;			//	}ʒu̎̃f[^A}f[^̎̃f[^ɐݒ
		pInsert->next = newData;				//	}ʒu̎̃f[^ɑ}

		if(pInsert == m_foot){					//	}ʒuL[̖Ȃ
			m_foot = newData;					//	ʒuXV
		}
	}

	m_dataCnt++;								//	f[^Z
	return &(newData->data);					//	GL[f[^ւ̃|C^Ԃ
}

QUEUE_EX_TEMPLATE BOOL CQueue_ExT::Dequeue(DATA* pData)
{
	if(m_head == NULL)		return FALSE;		//	L[Ȃ

	*pData = m_head->data;						//	f[^eݒ

	QUEUE_DATA* next = m_head->next;			//	̃f[^ւ̃|C^Ҕ
	if(m_look == m_head){						//	Qƈʒu擪Ȃ
		m_look = next;							//	Qƈʒũf[^Ɉړ
	}
	delete m_head;								//	
	m_head = next;								//	擪ʒuXV
	m_dataCnt--;								//	f[^Z

	if(m_head == NULL)		m_foot = NULL;		//	L[ɂȂ΁Aʒu
	return TRUE;
}

QUEUE_EX_TEMPLATE void CQueue_ExT::DeleteQueue()
{
	QUEUE_DATA* next;

	while(m_head != NULL){					//	L[łȂȂ
		next = m_head->next;				//	̃f[^
		delete m_head;						//	
		m_head = next;						//	擪ʒuXV
	}

	m_dataCnt = 0;							//	f[^
	m_head = m_foot = m_look = NULL;		//	e|C^
	m_error = FALSE;						//	̃G[
}

//////////////////////////////////////////////////////////////////////

QUEUE_EX_TEMPLATE BOOL CQueue_ExT::Seek(int idx)
{
	int i;

	m_look = m_head;						//	Qƈʒu擪ɐݒ
	for(i = 0; i < idx; i++){
		if(m_look->next == NULL){			//	̃f[^ȂȂ
			break;							//	I
		}

		m_look = m_look->next;				//	Qƈʒũf[^Ɉړ
	}

	if(i < idx)		return FALSE;			//	idx܂ňړłȂ
	else			return TRUE;
}

QUEUE_EX_TEMPLATE BOOL CQueue_ExT::GetData(DATA* pData)
{
	if(m_look == NULL)		return FALSE;	//	QƈʒuNULLȂ

	*pData = m_look->data;					//	f[^eݒ
	m_look = m_look->next;					//	Qƈʒũf[^Ɉړ
	return TRUE;
}

QUEUE_EX_TEMPLATE DATA* CQueue_ExT::GetPointer()
{
	if(m_look == NULL)		return NULL;	//	QƈʒuNULLȂ

	DATA* pData = &(m_look->data);			//	Qƈʒũf[^eւ̃|C^
	m_look = m_look->next;					//	Qƈʒũf[^Ɉړ
	return pData;
}

//////////////////////////////////////////////////////////////////////

QUEUE_EX_TEMPLATE BOOL CQueue_ExT::IsError()
{
	return m_error;
}

QUEUE_EX_TEMPLATE int CQueue_ExT::GetSize()
{
	return m_dataCnt;
}

QUEUE_EX_TEMPLATE void* CQueue_ExT::GetFootPointer()
{
	if(m_foot == NULL)	return (void *)&m_head;		//	L[̏ꍇAm_head̃AhXԂ
	else				return (void *)m_foot;		//	L[̖̃|C^
}

//////////////////////////////////////////////////////////////////////

QUEUE_EX_TEMPLATE CQueue_ExT& CQueue_ExT::operator =(CQueue_ExT& queue)
{
	DATA* pData;

	DeleteQueue();									//	L[폜
	queue.Seek(0);									//	Qƈʒu擪Ɉړ
	while((pData = queue.GetPointer()) != NULL){	//	ׂẴf[^GL[
		if(Enqueue(*pData) == NULL){				//	GL[Ɏs
			m_error = TRUE;							//	G[̃`FbN
			return *this;
		}
	}
	return *this;
}
