// Stack_Ex.h: CStack_Ex NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_STACK_EX_H__2E6E5CD0_A097_49BD_8D9B_4563B85E5168__INCLUDED_)
#define AFX_STACK_EX_H__2E6E5CD0_A097_49BD_8D9B_4563B85E5168__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define STACK_EX_TEMPLATE	template <typename DATA>
#define CStack_ExT			CStack_Ex<DATA>

STACK_EX_TEMPLATE class DLL_EXPORT CStack_Ex  
{
private:
	struct STACK_DATA{						//	X^bNp\
		DATA data;							//	f[^
		STACK_DATA* next;					//	̃f[^ւ̃|C^
	};

	BOOL m_error;							//	̃G[
	int m_dataCnt;							//	f[^
	STACK_DATA* m_top;						//	X^bN̒
	STACK_DATA* m_look;						//	Qƈʒu


public:
	CStack_Ex();
	virtual ~CStack_Ex();

	DATA* Push(DATA&);						//	vbV
	BOOL Pop(DATA*);						//	|bv
	void DeleteStack();						//	X^bN폜

	BOOL Seek(int);							//	w肳ꂽʒuɎQƈʒuړ
	BOOL GetData(DATA*);					//	Qƈʒũf[^擾iCNgtj
	DATA* GetPointer();						//	Qƈʒũ|C^擾iCNgtj

	BOOL IsError();							//	G[ĂꍇTRUEԂ
	int GetSize();							//	f[^擾

	CStack_ExT& operator =(CStack_ExT&);	//	iG[΍Kvj
};

#endif // !defined(AFX_STACK_EX_H__2E6E5CD0_A097_49BD_8D9B_4563B85E5168__INCLUDED_)



//////////////////////////////////////////////////////////////////////
// CStack_Ex
// \z/
//////////////////////////////////////////////////////////////////////

STACK_EX_TEMPLATE CStack_ExT::CStack_Ex()
{
	m_error = FALSE;		//	̃G[
	m_dataCnt = 0;			//	f[^
	m_top = NULL;			//	X^bN̒
	m_look = NULL;			//	Qƈʒu
}

STACK_EX_TEMPLATE CStack_ExT::~CStack_Ex()
{
	DeleteStack();			//	X^bN폜
}

//////////////////////////////////////////////////////////////////////

STACK_EX_TEMPLATE DATA* CStack_ExT::Push(DATA& data)
{
	STACK_DATA* newData = new STACK_DATA;	//	m
	if(newData == NULL)		return NULL;	//	mێs

	newData->data = data;					//	f[^eݒ
	newData->next = m_top;					//	X^bN̒ɒǉ
	m_top = newData;
	m_dataCnt++;							//	f[^Z
	return &(newData->data);				//	GL[f[^ւ̃|C^Ԃ
}

STACK_EX_TEMPLATE BOOL CStack_ExT::Pop(DATA* pData)
{
	if(m_top == NULL)	return FALSE;		//	X^bNȂ

	*pData = m_top->data;					//	f[^eݒ

	STACK_DATA* next = m_top->next;			//	̃f[^ւ̃|C^Ҕ
	if(m_look == m_top){					//	QƈʒuȂ
		m_look = next;						//	Qƈʒũf[^Ɉړ
	}
	delete m_top;							//	
	m_top = next;							//	ʒuXV
	m_dataCnt--;							//	f[^Z
	return TRUE;
}

STACK_EX_TEMPLATE void CStack_ExT::DeleteStack()
{
	STACK_DATA* next;

	while(m_top != NULL){					//	X^bNłȂȂ
		next = m_top->next;					//	̃f[^ւ̃|C^
		delete m_top;						//	
		m_top = next;						//	̃|C^XV
	}

	m_dataCnt = 0;							//	f[^
	m_top = m_look = NULL;					//	e|C^
	m_error = FALSE;						//	̃G[
}

//////////////////////////////////////////////////////////////////////

STACK_EX_TEMPLATE BOOL CStack_ExT::Seek(int idx)
{
	int i;

	m_look = m_top;							//	Qƈʒu𒸏ɐݒ
	for(i = 0; i < idx; i++){
		if(m_look->next == NULL){			//	̃f[^ȂȂ
			break;							//	I
		}

		m_look = m_look->next;				//	Qƈʒũf[^Ɉړ
	}

	if(i < idx)		return FALSE;			//	idx܂ňړłȂ
	else			return TRUE;
}

STACK_EX_TEMPLATE BOOL CStack_ExT::GetData(DATA* pData)
{
	if(m_look == NULL)		return FALSE;	//	QƈʒuNULLȂ

	*pData = m_look->data;					//	f[^eݒ
	m_look = m_look->next;					//	Qƈʒũf[^Ɉړ
	return TRUE;
}

STACK_EX_TEMPLATE DATA* CStack_ExT::GetPointer()
{
	if(m_look == NULL)		return NULL;	//	QƈʒuNULLȂ

	DATA* pData = &(m_look->data);			//	Qƈʒũf[^eւ̃|C^
	m_look = m_look->next;					//	Qƈʒũf[^Ɉړ
	return pData;
}

//////////////////////////////////////////////////////////////////////

STACK_EX_TEMPLATE BOOL CStack_ExT::IsError()
{
	return m_error;
}

STACK_EX_TEMPLATE int CStack_ExT::GetSize()
{
	return m_dataCnt;
}

//////////////////////////////////////////////////////////////////////

STACK_EX_TEMPLATE CStack_ExT& CStack_ExT::operator =(CStack_ExT& stack)
{
	DATA* pData;
	CStack_Ex<DATA*> reverseStack;					//	f[^̕яtɂp

	DeleteStack();									//	X^bN폜
	stack.Seek(0);									//	Qƈʒu𒸏Ɉړ
	while((pData = stack.GetPointer()) != NULL){	//	ׂẴf[^ւ̃|C^tpX^bNɃvbV
		if(reverseStack.Push(pData) == NULL){		//	vbVɎs
			m_error = TRUE;							//	G[̃`FbN
			return *this;
		}
	}

	reverseStack.Seek(0);							//	Qƈʒu𒸏Ɉړ
	while(reverseStack.GetData(&pData) != FALSE){	//	ׂẴf[^vbV
		if(Push(*pData) == NULL){					//	vbVɎs
			m_error = TRUE;							//	G[̃`FbN
			return *this;
		}
	}
	return *this;
}
